<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryRef" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="试卷id" prop="paperId">
        <el-input v-model="queryParams.paperId" placeholder="请输入试卷id" clearable @keyup.enter="handleQuery" />
      </el-form-item>
      <el-form-item label="题id" prop="questionId">
        <el-input v-model="queryParams.questionId" placeholder="请输入题id" clearable @keyup.enter="handleQuery" />
      </el-form-item>
      <el-form-item label="顺序" prop="seq">
        <el-input v-model="queryParams.seq" placeholder="请输入顺序" clearable @keyup.enter="handleQuery" />
      </el-form-item>
      <el-form-item label="分值" prop="score">
        <el-input v-model="queryParams.score" placeholder="请输入分值" clearable @keyup.enter="handleQuery" />
      </el-form-item>
      <el-form-item label="创建时间" prop="createTime">
        <el-date-picker clearable v-model="queryParams.createTime" type="date" value-format="YYYY-MM-DD"
          class="w-[170px]!" placeholder="请选择创建时间">
        </el-date-picker>
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="Search" @click="handleQuery">搜索</el-button>
        <el-button icon="Refresh" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button type="primary" plain icon="Plus" @click="handleAdd"
          v-hasPermi="['learn:paper_question:add']">新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="success" plain icon="Edit" :disabled="single" @click="handleUpdate"
          v-hasPermi="['learn:paper_question:edit']">修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="danger" plain icon="Delete" :disabled="multiple" @click="handleDelete"
          v-hasPermi="['learn:paper_question:remove']">删除</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="warning" plain icon="Download" @click="handleExport"
          v-hasPermi="['learn:paper_question:export']">导出</el-button>
      </el-col>
      <right-toolbar v-model:showSearch="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="paper_questionList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="试卷题id" align="center" prop="id" />
      <el-table-column label="试卷id" align="center" prop="paperId" />
      <el-table-column label="题id" align="center" prop="questionId" />
      <el-table-column label="顺序" align="center" prop="seq" />
      <el-table-column label="分值" align="center" prop="score" />
      <el-table-column label="创建时间" align="center" prop="createTime" width="180">
        <template #default="scope">
          <span>{{ parseTime(scope.row.createTime, '{y}-{m}-{d}') }}</span>
        </template>
      </el-table-column>
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template #default="scope">
          <el-button link type="primary" icon="Edit" @click="handleUpdate(scope.row)"
            v-hasPermi="['learn:paper_question:edit']">修改</el-button>
          <el-button link type="primary" icon="Delete" @click="handleDelete(scope.row)"
            v-hasPermi="['learn:paper_question:remove']">删除</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination v-show="total > 0" :total="total" v-model:page="queryParams.pageNum"
      v-model:limit="queryParams.pageSize" @pagination="getList" />

    <!-- 添加或修改试卷题关系对话框 -->
    <el-dialog :title="title" v-model="open" width="500px" append-to-body>
      <el-form ref="paper_questionRef" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="试卷id" prop="paperId">
          <el-input v-model="form.paperId" placeholder="请输入试卷id" />
        </el-form-item>
        <el-form-item label="题id" prop="questionId">
          <el-input v-model="form.questionId" placeholder="请输入题id" />
        </el-form-item>
        <el-form-item label="顺序" prop="seq">
          <el-input v-model="form.seq" placeholder="请输入顺序" />
        </el-form-item>
        <el-form-item label="分值" prop="score">
          <el-input v-model="form.score" placeholder="请输入分值" />
        </el-form-item>
      </el-form>
      <template #footer>
        <div class="dialog-footer">
          <el-button type="primary" @click="submitForm">确 定</el-button>
          <el-button @click="cancel">取 消</el-button>
        </div>
      </template>
    </el-dialog>
  </div>
</template>

<script setup name="Paper_question">
import { listPaper_question, getPaper_question, delPaper_question, addPaper_question, updatePaper_question } from "@/api/learn/paper_question"

const { proxy } = getCurrentInstance()

const paper_questionList = ref([])
const open = ref(false)
const loading = ref(true)
const showSearch = ref(true)
const ids = ref([])
const single = ref(true)
const multiple = ref(true)
const total = ref(0)
const title = ref("")

const data = reactive({
  form: {},
  queryParams: {
    pageNum: 1,
    pageSize: 10,
    paperId: null,
    questionId: null,
    seq: null,
    score: null,
    createTime: null
  },
  rules: {
    paperId: [
      { required: true, message: "试卷id不能为空", trigger: "blur" }
    ],
    questionId: [
      { required: true, message: "题id不能为空", trigger: "blur" }
    ],
    seq: [
      { required: true, message: "顺序不能为空", trigger: "blur" }
    ],
    score: [
      { required: true, message: "分值不能为空", trigger: "blur" }
    ],
  }
})

const { queryParams, form, rules } = toRefs(data)

/** 查询试卷题关系列表 */
function getList() {
  loading.value = true
  listPaper_question(queryParams.value).then(response => {
    paper_questionList.value = response.rows
    total.value = response.total
    loading.value = false
  })
}

// 取消按钮
function cancel() {
  open.value = false
  reset()
}

// 表单重置
function reset() {
  form.value = {
    id: null,
    paperId: null,
    questionId: null,
    seq: null,
    score: null,
    createTime: null
  }
  proxy.resetForm("paper_questionRef")
}

/** 搜索按钮操作 */
function handleQuery() {
  queryParams.value.pageNum = 1
  getList()
}

/** 重置按钮操作 */
function resetQuery() {
  proxy.resetForm("queryRef")
  handleQuery()
}

// 多选框选中数据
function handleSelectionChange(selection) {
  ids.value = selection.map(item => item.id)
  single.value = selection.length != 1
  multiple.value = !selection.length
}

/** 新增按钮操作 */
function handleAdd() {
  reset()
  open.value = true
  title.value = "添加试卷题关系"
}

/** 修改按钮操作 */
function handleUpdate(row) {
  reset()
  const _id = row.id || ids.value
  getPaper_question(_id).then(response => {
    form.value = response.data
    open.value = true
    title.value = "修改试卷题关系"
  })
}

/** 提交按钮 */
function submitForm() {
  proxy.$refs["paper_questionRef"].validate(valid => {
    if (valid) {
      if (form.value.id != null) {
        updatePaper_question(form.value).then(response => {
          proxy.$modal.msgSuccess("修改成功")
          open.value = false
          getList()
        })
      } else {
        addPaper_question(form.value).then(response => {
          proxy.$modal.msgSuccess("新增成功")
          open.value = false
          getList()
        })
      }
    }
  })
}

/** 删除按钮操作 */
function handleDelete(row) {
  const _ids = row.id || ids.value
  proxy.$modal.confirm('是否确认删除试卷题关系编号为"' + _ids + '"的数据项？').then(function () {
    return delPaper_question(_ids)
  }).then(() => {
    getList()
    proxy.$modal.msgSuccess("删除成功")
  }).catch(() => { })
}

/** 导出按钮操作 */
function handleExport() {
  proxy.download('learn/paper_question/export', {
    ...queryParams.value
  }, `paper_question_${new Date().getTime()}.xlsx`)
}

getList()
</script>
